/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the HttpHubspotStorageRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &HttpHubspotStorageRequest{}

// HttpHubspotStorageRequest struct for HttpHubspotStorageRequest
type HttpHubspotStorageRequest struct {
	Label     *string `json:"label,omitempty"`
	Type      *string `json:"type,omitempty"`
	OAuthId   *int32  `json:"o_auth_id,omitempty"`
	ApiObject *string `json:"apiObject,omitempty"`
}

// NewHttpHubspotStorageRequest instantiates a new HttpHubspotStorageRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewHttpHubspotStorageRequest() *HttpHubspotStorageRequest {
	this := HttpHubspotStorageRequest{}
	return &this
}

// NewHttpHubspotStorageRequestWithDefaults instantiates a new HttpHubspotStorageRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewHttpHubspotStorageRequestWithDefaults() *HttpHubspotStorageRequest {
	this := HttpHubspotStorageRequest{}
	return &this
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *HttpHubspotStorageRequest) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *HttpHubspotStorageRequest) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *HttpHubspotStorageRequest) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *HttpHubspotStorageRequest) SetLabel(v string) {
	o.Label = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *HttpHubspotStorageRequest) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *HttpHubspotStorageRequest) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *HttpHubspotStorageRequest) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *HttpHubspotStorageRequest) SetType(v string) {
	o.Type = &v
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *HttpHubspotStorageRequest) GetOAuthId() int32 {
	if o == nil || IsNil(o.OAuthId) {
		var ret int32
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *HttpHubspotStorageRequest) GetOAuthIdOk() (*int32, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *HttpHubspotStorageRequest) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given int32 and assigns it to the OAuthId field.
func (o *HttpHubspotStorageRequest) SetOAuthId(v int32) {
	o.OAuthId = &v
}

// GetApiObject returns the ApiObject field value if set, zero value otherwise.
func (o *HttpHubspotStorageRequest) GetApiObject() string {
	if o == nil || IsNil(o.ApiObject) {
		var ret string
		return ret
	}
	return *o.ApiObject
}

// GetApiObjectOk returns a tuple with the ApiObject field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *HttpHubspotStorageRequest) GetApiObjectOk() (*string, bool) {
	if o == nil || IsNil(o.ApiObject) {
		return nil, false
	}
	return o.ApiObject, true
}

// HasApiObject returns a boolean if a field has been set.
func (o *HttpHubspotStorageRequest) HasApiObject() bool {
	if o != nil && !IsNil(o.ApiObject) {
		return true
	}

	return false
}

// SetApiObject gets a reference to the given string and assigns it to the ApiObject field.
func (o *HttpHubspotStorageRequest) SetApiObject(v string) {
	o.ApiObject = &v
}

func (o HttpHubspotStorageRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o HttpHubspotStorageRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	if !IsNil(o.OAuthId) {
		toSerialize["o_auth_id"] = o.OAuthId
	}
	if !IsNil(o.ApiObject) {
		toSerialize["apiObject"] = o.ApiObject
	}
	return toSerialize, nil
}

type NullableHttpHubspotStorageRequest struct {
	value *HttpHubspotStorageRequest
	isSet bool
}

func (v NullableHttpHubspotStorageRequest) Get() *HttpHubspotStorageRequest {
	return v.value
}

func (v *NullableHttpHubspotStorageRequest) Set(val *HttpHubspotStorageRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableHttpHubspotStorageRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableHttpHubspotStorageRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableHttpHubspotStorageRequest(val *HttpHubspotStorageRequest) *NullableHttpHubspotStorageRequest {
	return &NullableHttpHubspotStorageRequest{value: val, isSet: true}
}

func (v NullableHttpHubspotStorageRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableHttpHubspotStorageRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
